#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileoutput.h"
#include "nokia.h"
#include "general.h"

/*

Ringtone Tools - Copyright 2001-2003 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

/* BMP */

void write_bmp_header(FILE *out, struct note_t *note)
{
int image_size;

  image_size=note->width/8;
  if (note->width%8>0) image_size++;
  if (image_size%4!=0)
  {
    image_size=image_size+(4-(image_size%4));
  }

  write_chars(out,"BM");
  write_long(out,0);
  write_word(out,0);
  write_word(out,0);
  write_long(out,62);

/* head1: 14  head2: 40  colors: 8 */

  write_long(out,40);         /* biSize */
  write_long(out,note->width);
  write_long(out,note->height);
  write_word(out,1);
  write_word(out,1);
  write_long(out,0);          /* compression */
  write_long(out,image_size);
  write_long(out,0);          /* biXPelsperMetre */
  write_long(out,0);          /* biYPelsperMetre */
  write_long(out,2);
  write_long(out,2);

  putc(0,out);
  putc(0,out);
  putc(0,out);
  putc(0,out);
  putc(255,out);
  putc(255,out);
  putc(255,out);
  putc(0,out);
}

void write_bmp_footer(FILE *out, struct note_t *note)
{
int x,y;
int bytec,padding=0;
int data_length;

  bytec=note->width/8;
  if (note->width%8!=0) bytec++;

  if (bytec%4!=0) padding=4-(bytec%4);

  for (y=note->height-1; y>=0; y--)
  {
    for (x=0; x<bytec; x++)
    {
      putc(ring_stack[y*bytec+x],out);
    }

    for (x=0; x<padding; x++)
    { putc(0,out); }
  }

  data_length=ftell(out);
  fseek(out,2,SEEK_SET);
  write_long(out,data_length);
  fseek(out,data_length,SEEK_SET);
}

void write_text_footer(FILE *out, struct note_t *note)
{
int x,y,b,d;
int bytec;

  bytec=note->width/8;
  if (note->width%8!=0) bytec++;

  for (y=0; y<note->height; y++)
  {
    for (x=0; x<bytec; x++)
    {
      d=ring_stack[y*bytec+x];

      for (b=7; b>=0; b--)
      {
        if ((d&(1<<b))==0)
        { putc(' ',out); }
          else
        { putc('*',out); }
      }
    }
    putc('\n',out);
  }
}

